// IC calibration class
// 

#ifndef _TARTCALIBIC_H_
#define _TARTCALIBIC_H_

#include <TClonesArray.h>
#include <TString.h>

class TArtRawEventObject;
class TArtRawSegmentObject;
class TArtICPara;
class TArtBigRIPSParameters;
class TArtIC;
class TArtStoreManager;

class TArtCalibIC  {

 public:

  TArtCalibIC();
  virtual ~TArtCalibIC();

  void Initialize();
  void LoadData();
  void LoadData(TArtRawSegmentObject *);
  void ClearData();
  void ReconstructData();

  bool IsReconstructed(){ return fReconstructed; }

  // function to access data container
  TClonesArray    * GetICArray(){return fICArray;}
  Int_t             GetNumIC();
  TArtIC          * GetIC(int i);
  TArtICPara      * GetICPara(int i);
  // looking for ic whose id is i. return NULL in the case of fail to find.
  TArtIC          * FindIC(int i);
  // looking for ic whose name is i. return NULL in the case of fail to find.
  TArtIC          * FindIC(TString *n);
  TArtIC          * FindIC(char *n);

 private:

  bool fDataLoaded;
  bool fReconstructed;

  TClonesArray       * fICArray;
  // temporal buffer for pointer for ic parameter
  std::vector <TArtICPara*> fICParaArray;

  TArtBigRIPSParameters * setup;
  TArtStoreManager * sman;

  ClassDef(TArtCalibIC,1);

};

#endif
