#ifndef _TARTPLASTIC_H_
#define _TARTPLASTIC_H_

#include "TNamed.h"
#include "TString.h"

class TArtPlastic : public TNamed {

 public:
  TArtPlastic(){id=-1;fpl=-1;zposition=-1;zoffset=0;fTLRaw=-1;fTRRaw=-1;fQLRaw=-1;fQRRaw=-1;fTime=-1;fTimeL=-1;fTimeR=-1;fTimeLSlew=-1;fTimeRSlew=-1;fTimeSlew=-1;}
  virtual ~TArtPlastic(){}

  virtual void SetID(int val){id = val;}
  virtual void SetDetectorName(TString val){name = val;}
  virtual void SetFpl(int val){fpl = val;}
  virtual void SetZoffset(Double_t val){zoffset = val;}
  virtual void SetZposition(Double_t val){zposition = val;}

  virtual int  GetID(){return id;}
  virtual TString * GetDetectorName(){return &name;}
  virtual int  GetFpl(){return fpl;}
  virtual Double_t GetZoffset(){return zoffset;}
  virtual Double_t GetZposition(){return zposition;}

  // function to set raw data
  void  SetTLRaw(int val){fTLRaw = val;}
  void  SetTRRaw(int val){fTRRaw = val;}
  void  SetQLRaw(int val){fQLRaw = val;}
  void  SetQRRaw(int val){fQRRaw = val;}

  // function to get raw data
  unsigned int GetTLRaw(){return fTLRaw;}
  unsigned int GetTRRaw(){return fTRRaw;}
  unsigned int GetQLRaw(){return fQLRaw;}
  unsigned int GetQRRaw(){return fQRRaw;}
 
  // get reconstructed values
  virtual void SetTime(Double_t val){fTime=val;}
  virtual void SetTimeL(Double_t val){fTimeL=val;}
  virtual void SetTimeR(Double_t val){fTimeR=val;}
  virtual void SetTimeLSlew(Double_t val){fTimeLSlew=val;}
  virtual void SetTimeRSlew(Double_t val){fTimeRSlew=val;}
  virtual void SetTimeSlew (Double_t val){fTimeSlew=val;}

  // get reconstructed values
  Double_t GetTime(){return fTime;}
  Double_t GetTimeL(){return fTimeL;}
  Double_t GetTimeR(){return fTimeR;}
  Double_t GetTimeLSlew(){return fTimeLSlew;}
  Double_t GetTimeRSlew(){return fTimeRSlew;}
  Double_t GetTimeSlew (){return fTimeSlew;}

 private:
  int id;
  int fpl;
  TString name;
  Double_t     zposition; // global position
  Double_t     zoffset; // offset in a fpl

  // raw data
  unsigned int fTLRaw;  
  unsigned int fTRRaw;
  unsigned int fQLRaw;  
  unsigned int fQRRaw;

  // reconstructed data
  Double_t   fTime;
  Double_t   fTimeL;
  Double_t   fTimeR;
  Double_t   fTimeLSlew; // after slewing correction
  Double_t   fTimeRSlew;
  Double_t   fTimeSlew;

  ClassDef(TArtPlastic,1);

};
#endif

